#ifndef _ADATA_PLATFORM_MUTEX_H
#define _ADATA_PLATFORM_MUTEX_H

#include <vxWorks.h>
#include <semLib.h>
#include <sysLib.h>

#define PORTABLE_MUTEX_HANDLE_INVALID_VALUE NULL
typedef SEM_ID PortableMutexHandle;

#if defined(_WRS_INLINE)
_WRS_INLINE PortableMutexHandle
#else
static __inline__ PortableMutexHandle
#endif
portableMutexCreate(
  void)
{
  return semMCreate(0);
}

#if defined(_WRS_INLINE)
_WRS_INLINE void
#else
static __inline__ void
#endif
portableMutexDestroy(
  PortableMutexHandle m)
{
  semDelete(m);
}

#if defined(_WRS_INLINE)
_WRS_INLINE void
#else
static __inline__ void
#endif
portableMutexGive(
  PortableMutexHandle m)
{
  semGive(m);
}

#if defined(_WRS_INLINE)
_WRS_INLINE void
#else
static __inline__ void
#endif
portableMutexTake(
  PortableMutexHandle m)
{
  STATUS status;
  
  status = semTake(m, WAIT_FOREVER);
  assert(status == OK);
}

#endif
