/*
** File: dmabus.h  
** Project: ADMXRC3 module driver
** Purpose: Defines function prototypes for OS-independent IOCTL handlers for
**          ADMXRC3_*DMABus functions.
**
** (C) Copyright Alpha Data 2011
*/

#if !defined(ADATA_ADMXRC3_DMABUS_H)
#define ADATA_ADMXRC3_DMABUS_H

#include <df.h>
#include "device.h"

extern DfIoStatus
ioctlReadDmaBus(
	Admxrc3DeviceContext* pDevCtx,
  Admxrc3ClientContext* pClCtx,
  DfClientRequest* pReq,
  void* pBuffer,
  unsigned int inSize);

extern DfIoStatus
ioctlReadDmaBusThunk(
	Admxrc3DeviceContext* pDevCtx,
  Admxrc3ClientContext* pClCtx,
  DfClientRequest* pReq,
  void* pBuffer,
  unsigned int inSize);

extern DfIoStatus
ioctlWriteDmaBus(
	Admxrc3DeviceContext* pDevCtx,
  Admxrc3ClientContext* pClCtx,
  DfClientRequest* pReq,
  void* pBuffer,
  unsigned int inSize);

extern DfIoStatus
ioctlWriteDmaBusThunk(
	Admxrc3DeviceContext* pDevCtx,
  Admxrc3ClientContext* pClCtx,
  DfClientRequest* pReq,
  void* pBuffer,
  unsigned int inSize);

#endif
